import { View, ScrollView, Button } from '@tarojs/components'
import React, { useCallback, memo, useEffect, useMemo, useRef, useState, ReactNode } from 'react'
import styles from "./index.module.scss"
import classnames from "classnames";
import Taro, { usePullDownRefresh, useRouter, useDidShow } from '@tarojs/taro';
import { alert } from '@/common/common'
import { formatPriceDiv, formatDateTime, formatWeightDiv } from '@/common/format'
import IconFont from '@/components/iconfont/iconfont'
import Popup from '@/components/popup';
import { goLink } from '@/common/common'
interface Props {
    showPopup: boolean,
    handClose: () => void,
    purchaser_id?: string | number

}
export default memo((props: Props) => {


    //标签
    const [modeList, setModeList] = useState<any[]>([{ id: -1, name: '不限' }, { id: 0, name: '大货' }, { id: 1, name: '剪版' }, { id: 2, name: '散剪' }, { id: 3, name: '新开发客户' }])
    //选择标签
    const handCheckMode = (item) => {
        modeList.map(it => {
            if (it.id === item.id) {
                it.checked = !it.checked
            }
            return it
        })
        setModeList([...modeList])
    }

    const handReset = () => {
        modeList.map(it => {
            it.checked = false
            return it
        })
        setModeList([...modeList])
    }

    const handSure = () => {

    }

    const isDisabled = useMemo(() => {
        let arr = modeList.filter(item => { return item.checked })
        if (arr.length) {
            return false
        } else {
            return true
        }
    }, [modeList])

    const choseNums = useMemo(() => {
        let arr = modeList.filter(item => { return item.checked })
        return arr.length
    }, [modeList])

    return (
        <Popup title={'选择标签'} show={props.showPopup} onClose={() => { props.handClose() }}>
            <ScrollView scrollY className={styles.scrollView}>
                <View className={styles.thirdBox}>
                    <View className={styles.thirdTopfont}>自定义标签分组</View>
                    <View className={styles.flexModebox}>
                        {modeList.map((item, index) => {
                            return (
                                <View
                                    onClick={() => {
                                        handCheckMode(item)
                                    }}
                                    className={classnames(item.checked ? styles.activemodeBox : styles.modeBox)}
                                    key={index}>
                                    {item.name}
                                </View>
                            )
                        })}
                    </View>
                </View>
            </ScrollView>
            <View className={styles.bottomBox}>
                <Button
                    className={styles.resetBox}
                    onClick={() => {
                        handReset()
                    }}>
                    重置
                </Button>
                <Button
                    className={classnames(isDisabled ? styles.button : styles.activeButton)}
                    disabled={isDisabled}
                    onClick={() => {
                        handSure?.()
                    }}>

                    保存({choseNums})
                </Button>
            </View>
        </Popup>
    )
})