import { View, ScrollView } from '@tarojs/components'
import React, { useCallback, memo, useEffect, useMemo, useRef, useState, ReactNode } from 'react'
import styles from "./index.module.scss"
import classnames from "classnames";
import Taro, { usePullDownRefresh, useRouter, useDidShow } from '@tarojs/taro';
import { alert } from '@/common/common'
import { formatPriceDiv, formatDateTime, formatWeightDiv } from '@/common/format'
import DropDownItem from '@/components/dropDown-item'
import { GetAddressListApi } from "@/api/addressList";
import Tabs from "../tabs"
import IconFont from '@/components/iconfont/iconfont';
interface Props {
    handCity?: (any) => void
}

export default memo((props: Props) => {

    const DropDownItemRef = useRef<any>()
    // const close = () => {
    //     DropDownItemRef.current.closePopup()
    // }

    //获取地址
    const { fetchData } = GetAddressListApi()
    useEffect(() => {
        getProvince()
    }, [])


    //获取省
    const getProvince = async () => {
        let res = await fetchData({ parent_id: 1 })
        if (res.data) {
            setlist([...res.data.list])
        }
    }




    //省数组
    const [list, setlist] = useState<any[]>([])
    //区数组
    const [cityList, setcityList] = useState<any[]>([])

    //区分在哪一栏
    const [currentValue, setCurrentValue] = useState<number>(1)

    //顶部栏
    const [TarBarList, setTarBarList] = useState<any[]>([{ id: 1, name: '选择省', showBorder: true }, { id: 2, name: '选择市', showBorder: false }])
    const handChose = (item) => {
        TarBarList.map(it => {
            if (it.id === item.id) {
                it.showBorder = true
            } else {
                it.showBorder = false
            }
            setTarBarList([...TarBarList])
            setCurrentValue(item.id)
        })
    }

    //选择省
    const handProvince = (item) => {
        list.map(it => {
            if (item.id == it.id) {
                it.check = true
            } else {
                it.check = false
            }
            return it
        })
        setlist([...list])
        getCity(item.id)
        setCurrentValue(2)
        TarBarList.map(it => {
            if (it.id == currentValue) {
                it.name = item.name
                it.showBorder = false

            } else {
                it.showBorder = true
            }

            return it
        })
        setTarBarList([...TarBarList])
    }

    //获取市
    const getCity = async (id) => {
        let res = await fetchData({ parent_id: id })
        if (res.data) {
            setcityList([...res.data.list])
        }
    }


    //选择市
    const handCity = (item) => {
        cityList.map(it => {
            if (item.id == it.id) {
                it.check = !it.check
            }
            return it
        })
        setcityList([...cityList])
        let arr = cityList.filter(next => { return next.check })
        props.handCity?.(arr)
    }

    return (
        <DropDownItem ref={DropDownItemRef} title={'所有省市'} value={-1} activeColor='#337fff'>
            <View className={styles.mainBox}>
                <Tabs list={TarBarList} handChose={(item) => handChose?.(item)}></Tabs>
                {
                    currentValue == 1 && <ScrollView scrollY className={styles.scrollView}>
                        {
                            list.map(item => {
                                return (
                                    <View className={styles.itemBox} onClick={() => handProvince(item)}>
                                        <View className={classnames(item.check ? styles.activeitemProvince : styles.itemProvince)}>{item.name}</View>
                                        <IconFont name={'icon-chakanquanbukehu'} size={50} color={'#d8d8d8'}></IconFont>
                                    </View>
                                )
                            })
                        }
                    </ScrollView>
                }
                {
                    currentValue == 2 && <ScrollView scrollY className={styles.scrollView}>
                        {
                            cityList.map(item => {
                                return (
                                    <View className={styles.itemBox} onClick={() => handCity(item)}>
                                        <View className={classnames(item.check ? styles.activeitemProvince : styles.itemProvince)}>{item.name}</View>
                                        {/* <IconFont name={'icon-chakanquanbukehu'} size={50} color={'#d8d8d8'}></IconFont> */}
                                    </View>
                                )
                            })
                        }
                    </ScrollView>
                }
            </View>
        </DropDownItem>
    )
})